require_relative "action"

module Rookout
  module Augs
    module Actions
      class ActionRunProcessor < Action
        def initialize arguments, processor_factory
          @processor = processor_factory.create_processor arguments["operations"]

          post_operations = arguments["post_operations"]
          if post_operations
            @post_processor = processor_factory.create_processor post_operations
          else
            @post_processor = nil
          end
        end

        def execute aug_id, report_id, namespace, output
          @processor.process namespace
          output.send_user_message aug_id, report_id, namespace.read_attribute("store")
          return unless @post_processor

          output.flush_message
          @post_processor.process namespace
        end
      end
    end
  end
end
