module Rookout
  module Augs
    require_relative "../../logger"

    require_relative "../../processor/rook_error"

    module Locations
      require_relative "location"

      class LocationFileLine < Location
        NAME = "file_line".freeze

        def initialize arguments, output, aug
          super output, aug
          @filename = arguments["filename"]
          @lineno = arguments["lineno"]

          # NOTE: Hashes are only used for suggestions, not for verification
          @file_hash = arguments["sha256"]
          @line_crc = arguments["line_crc32_2"]
          @line_unique = arguments["line_unique"] || false
        end

        attr_reader :filename, :lineno, :file_hash, :line_crc, :line_unique

        def add_aug trigger_services
          trigger_services.get_service("position").add_aug self
        rescue SystemExit
          raise
        rescue Exception => e
          message = "Exception when adding aug"
          Logger.instance.error message, e
          notify_error Processor::RookError.new e, message
        end
      end
    end
  end
end
