module Rookout
  module ComWs
    require_relative "../config"

    class Backoff
      def initialize
        @connect_time = nil
        reset_backoff
      end

      def after_disconnect
        reset_backoff if @connect_time && Time.new > @connect_time + Config.backoff_reset_time
        @connect_time = nil

        sleep @next_backoff
        @next_backoff = [@next_backoff * 2, Config.backoff_max_time].min
      end

      def after_connect
        @connect_time = Time.now
      end

      private

      def reset_backoff
        @next_backoff = Config.backoff_factor
      end
    end
  end
end
