module Rookout
  module ComWs
    require_relative "../logger"

    class Pinger
      def initialize connection, interval, timeout
        @interval = interval
        @timeout = timeout
        @connection = connection

        @last_pong = Time.now
        @last_ping = Time.now
      end

      def repeat
        loop do
          if Time.now - @last_ping > @interval
            Logger.instance.debug "Sending Ping"
            @last_ping = Time.now
            begin
              @connection.ping Time.now.to_s do
                Logger.instance.debug "Got Ping reply"
                @last_pong = Time.now
              end
            rescue RuntimeError, Errno::EPIPE
              Logger.instance.debug "Failed to send ping"
              break
            end
          end

          if Time.now - @last_pong > @timeout
            Logger.instance.debug "Ping timeout"
            break
          end

          yield
        end
      end
    end
  end
end
