module Rookout
  require_relative "version"
  require_relative "commit"

  module Config
    # Magic to allow for module variables to be easily accessible
    class << self
      attr_accessor :debug
      Rookout::Config.debug = false

      attr_accessor :logger_filename, :logger_log_to_stderr, :logger_log_level
      Rookout::Config.logger_filename = "rookout/ruby-rook.log".freeze
      Rookout::Config.logger_log_to_stderr = false
      Rookout::Config.logger_log_level = :info

      attr_accessor :agent_com_configuration_command_thread_name,
                    :agent_com_max_message_limit,
                    :agent_com_timeout,
                    :agent_com_ping_interval,
                    :agent_com_ping_timeout,
                    :agent_com_flush_timeout,
                    :agent_com_max_queued_messages
      Rookout::Config.agent_com_max_message_limit = 1024 * 1024
      Rookout::Config.agent_com_timeout = 3
      Rookout::Config.agent_com_ping_interval = 10
      Rookout::Config.agent_com_ping_timeout = 30
      Rookout::Config.agent_com_flush_timeout = 3
      Rookout::Config.agent_com_max_queued_messages = 100

      attr_accessor :backoff_factor, :backoff_reset_time, :backoff_max_time
      Rookout::Config.backoff_factor = 0.2
      Rookout::Config.backoff_max_time = 60
      Rookout::Config.backoff_reset_time = 3 * 60.0

      attr_accessor :output_max_status_updates,
                    :output_max_aug_messages,
                    :output_max_log_items,
                    :output_bucket_refresh_rate
      Rookout::Config.output_max_status_updates = 200
      Rookout::Config.output_max_aug_messages = 100
      Rookout::Config.output_max_log_items = 200
      Rookout::Config.output_bucket_refresh_rate = 10

      attr_accessor :instrumentation_max_aug_time
      Rookout::Config.instrumentation_max_aug_time = 400

      attr_accessor :user_git_commit, :user_git_origin
      Rookout::Config.user_git_commit = nil
      Rookout::Config.user_git_origin = nil

      attr_accessor :rookout_version, :rookout_commit
      Rookout::Config.rookout_version = Rookout::VERSION
      Rookout::Config.rookout_commit = Rookout::COMMIT
    end
  end
end
