module Rookout
  module Processor
    module NamespaceSerializer
      require_relative "../logger"

      require_relative "../protobuf/variant_pb"

      module_function

      def dump namespace, log_errors = true
        namespace.dump log_errors
      rescue StandardError => e
        message = "Failed to serialize namespace"
        variant = Com::Rookout::Variant.new variant_type: :VARIANT_ERROR

        if log_errors
          Logger.instance.exception message, e

          error = RookError.new e, message
          variant.error_value = error.dumps
        end
        variant
      end
    end
  end
end
