module Rookout
  module Processor
    module Namespaces
      require_relative "namespace"
      require_relative "ruby_object_namespace"

      require_relative "../../exceptions"

      require_relative "../../protobuf/variant_pb"

      class ContainerNamespace < Namespace
        def initialize hash = {}
          @hash = hash
        end

        def call_method name, args
          return RubyObjectNamespace.new @hash.length if name == "size"
          super
        end

        def read_attribute name
          raise Exceptions::RookAttributeNotFound, name unless @hash.key? name
          @hash[name]
        end

        def write_attribute name, value
          @hash[name] = value
        end

        def dump log_object_errors
          variant = Com::Rookout::Variant.new variant_type: :VARIANT_NAMESPACE,
                                              namespace_value: Com::Rookout::Variant::Namespace.new

          @hash.each do |key, value|
            dumped_value = value.dump log_object_errors
            namespace = Com::Rookout::Variant::NamedValue.new name: key, value: dumped_value
            variant.namespace_value.attributes << namespace
          end

          variant
        end
      end
    end
  end
end
