module Rookout
  module Processor
    module Namespaces
      class Namespace
        require_relative "../../exceptions"
        def call_method name, _args
          raise Exceptions::RookMethodNotFound.new(self.class.to_s, name)
        end

        def read_attribute name
          raise Exceptions::RookAttributeNotFound, name
        end

        def write_attribute name, _value
          raise Exceptions::RookWriteAttributeNotSupported.new(self.class.to_s, name)
        end

        def read_key key
          raise Exceptions::RookKeyNotFound, key
        end

        def dump _log_object_errors
          raise NotImplementedError
        end
      end
    end
  end
end
