module Rookout
  module Processor
    module Namespaces
      require_relative "namespace"
      require_relative "frame_namespace"
      require_relative "traceback_namespace"

      class StackNamespace < Namespace
        def initialize backtrace, offset = 0
          @backtrace = backtrace
          @offset = offset
        end

        def read_key key
          FrameNamespace.new @backtrace[key + @offset]
        end

        def call_method name, args
          return create_traceback args if name == "traceback"
          super
        end

        def create_traceback args
          args = 1000 if args == ""
          TracebackNamespace.new @backtrace, @offset, args.to_i
        end
      end
    end
  end
end
