module Rookout
  module Processor
    require_relative "rook_error"
    require_relative "../logger"
    require_relative "../user_warnings"

    class Processor
      def initialize configuration, factory
        @operations = []

        configuration.each do |it|
          operation = factory.create_operation it
          @operations.push operation
        end
      end

      def process namespace
        @operations.each do |operation|
          result = nil
          begin
            result = operation.execute namespace
          rescue StandardError => e
            message = "Error in operation"
            Logger.instance.exception message, e
            warning = RookError.new e, message
            UserWarnings.notify_warning warning
          end

          return result unless result.nil?
        end
      end
    end
  end
end
