module Rookout
  module Processor
    require_relative "processor"
    require_relative "operations/set_operation"
    require_relative "paths/arithmetic_path"

    class ProcessorFactory
      def initialize; end

      def create_operation configuration
        Operations::SetOperation.new configuration, self
      end

      def create_path configuration
        Paths::ArithmeticPath.new configuration
      end

      def create_processor configuration
        Processor.new configuration, self
      end
    end
  end
end
