module Rookout
  require_relative "services/tracer"
  require_relative "services/position"

  class TriggerServices
    def initialize
      super

      @services = {}
    end

    def get_service name
      @services[name]
    end

    def remove_aug aug_id
      @services.each_value { |service| service.remove_aug aug_id }
    end

    def clear_augs
      @services.each_value(&:clear_augs)
    end

    def start
      @services["tracer"] = Services::Tracer.new
      @services["position"] = Services::PositionResolver.new @services["tracer"]
    end

    def close
      @services.each_value(&:close)
      @services = {}
    end
  end
end
