module Rookout
  module UserWarnings
    TLS_KEY = :ROOKOUT_USER_WARNINGS

    def with aug, &block
      thread = Thread.current
      begin
        thread[TLS_KEY] = aug
        block.call
      ensure
        thread[:ROOKOUT_USER_WARNINGS] = nil
      end
    end

    def notify_warning error
      aug = Thread.current[TLS_KEY]
      aug.notify_warning error unless aug.nil?
    end

    def notify_error error
      aug = Thread.current[TLS_KEY]
      aug.notify_error error unless aug.nil?
    end

    module_function :with, :notify_warning, :notify_error
  end
end
